<template>
  <VToolbar
    class="l-toolbar"
    :height="48"
    app
    flat
  >
    <VToolbarSideIcon
      v-if="$vuetify.breakpoint.smAndDown"
      large
      @click="toggleDrawer"
    />

    <img
      :src="require(`@/assets/sw/logo-${dark ? 'light' : 'dark'}.png`)"
      style="max-width: 190px"
    >

    <!-- center -->
    <VSpacer />

    <VToolbarItems v-if="$vuetify.breakpoint.mdAndUp">
      <VBtn
        v-for="(c, i) in children"
        :key="i"
        class="l-btn"
        :to="c.path"
        flat
      >
        {{ c.name }}
      </VBtn>
    </VToolbarItems>

    <!-- right -->
    <VSpacer />

    <VTooltip bottom>
      <template v-slot:activator="{ on }">
        <VBtn
          large
          icon
          @click="toggleDark"
          v-on="on"
        >
          <VIcon>invert_colors</VIcon>
        </VBtn>
      </template>
      <span>Inverter a cor</span>
    </VTooltip>

    <VDivider
      class="mx-3"
      inset
      vertical
    />

    <VTooltip bottom>
      <template v-slot:activator="{ on }">
        <VBtn
          large
          icon
          href="//gitlab.com/i.leonardo/ativ-vue-api-swapi"
          target="_blank"
          v-on="on"
        >
          <img
            :src="require(`@/assets/github/logo-${dark ? 'light' : 'dark'}.png`)"
            width="24px"
          >
        </VBtn>
      </template>
      <span>GitHub</span>
    </VTooltip>
  </VToolbar>
</template>

<script lang="ts">
import { Vue, Component, Provide } from 'vue-property-decorator';

// State Management
import { store, mutations } from '@/observable';

// Router
import { children, Children } from '@/router/modules/page';

@Component({
  computed: {
    dark() {
      return store.dark;
    },
  },

  methods: {
    toggleDark: mutations.toggleDark,
    toggleDrawer: mutations.toggleDrawer,
  },
})
export default class LHeader extends Vue {
  dark!: boolean

  toggleDark!: void

  toggleDrawer!: void

  children: Children[] = []

  created() {
    this.children = children;
  }
}
</script>

<style lang="stylus">
  .l-toolbar
    .l-btn
      &:before
        background transparent
      &:hover
        &:before
          opacity .5
          background-color #ffcc00
          height 4px
      &.v-btn--active
        &:before
          opacity 1
          border-bottom 4px solid #ffcc00
    /.theme--light &
      background-color white
      border-bottom 1px solid #ccc
    /.theme--dark &
      border-bottom 1px solid black
</style>
